sampler s0 : register(s0);

float dimX;
float dimY;
float dimZ;
float4 waveColor;

struct PS_INPUT
{
	float4 diffuse : COLOR0;  
	float2 texCoord : TEXCOORD0; 
	float2 vPos : VPOS; 
};

struct PS_OUTPUT
{
    	float4 color : COLOR0; 
};

float2 Ripple( float2 xy )
{
	float2 result;

	float2 cp = {dimX,dimY};
	float2 v1 = cp - xy;
	float d = length(v1);
	v1 = normalize(v1);
	result = v1 * (cos((d*6.28)+dimZ) * d);

	return result;
}

PS_OUTPUT PsShader( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;
	float2 uv = In.texCoord;

	uv = Ripple(uv);

	float4 colorTexture = tex2D(s0,uv);
	float4 colorDiffuse = In.diffuse;
	float4 color = colorTexture * colorDiffuse;

	color.rgb *= 1 - (1 - waveColor.rgb);
	color.rgb += waveColor.rgb * 0.1;
	color.a = waveColor.a;

	Out.color = color;

	return Out;
}

technique Normal
{
	pass P0
    	{
        	PixelShader = compile ps_3_0 PsShader();
    	}
}


